//#include <curses.h>
#include <unistd.h>
#include <stdio.h>
#include <string>
#include <string.h>
#include <sys/types.h>
#include <iostream.h>
#include <sys/time.h>
#include <sys/resource.h>
#include <sys/wait.h>
#include <vector>
#include <errno.h>

#include "myshell.h"
#include "define.h"

#include <fstream.h>
#include <iostream.h>

extern int errno;
extern char **environ;
#define STRING std::string
//WINDOW * mywindow;
STRING previous;
int addUsrPid;
bool keeploop;

struct user{
	user( STRING myname, char myrole){ name = myname; role = myrole; }
	STRING name;
	char role;
};

std::vector<user> users;
int fds[2];
//int rfds[2];

void addUser( user usr){
	users.push_back(usr);
}

char findUser( STRING name){
//	printf("%s, %d\n", name.c_str(), name.size());
	
	for( int i = 0; i < users.size(); i++)
	{
		if( users[i].name == name)
			return users[i].role;
		
//		printf("\t%d.%s, %d\n", i, users[i].name.c_str(),users[i].name.size());	
	}

	return '0';
}


void handler1(int signum)
{			
	size_t size;
	char temp[256];
	char temptowrite;
	
	read( INPUTFILE, &size, sizeof(size));
	read( INPUTFILE, temp, size);
	temp[size] = 0;

	previous = temp;
//	printf( "Size: %d\n", strlen(temp));

	temptowrite = findUser( previous);

//	printf("Find #: %d\n", tempint);
	
//	if( tempint == 0)
//		temptowrite = '0';
//	else
//		temptowrite = users[tempint].role;
//	ofstream fi("sahra");
//        fi << "I'm here sir!!\n" << tempint << endl;
//        fi.close();

//	read( INPUTFILE, &size, 1);
//	printf("Injam!!\n");


	write( OUTPUTFILE, &temptowrite, sizeof(temptowrite));
	
	if( kill( addUsrPid, SIGUSR1) != 0)
		printf("Internal error!!\n");
}

void handler2(int signum)
{	
	char get;
	read( INPUTFILE, &get, sizeof(get));
	
	if( get != NOTFOUND)
		addUser( user( previous, get));

	keeploop = false;

//	printf("In vect: %c\n", users[users.size() - 1].role);
	
//	ofstream fi("sahra");
//      fi << users.size() << endl << (int)get;
//        fi.close();
}

int main()
{
//	char * temp = new char[200];
//	int temp2;
	signal(SIGUSR1, &handler1);
	signal(SIGUSR2, &handler2);
	
	if( pipe( fds) != 0)// || pipe( rfds) != 0)
	{
		cout << "Cannot establish pipe!!" << endl;
		return 0;
	}

	if( dup2( fds[0], INPUTFILE) == -1 || dup2( fds[1], OUTPUTFILE) == -1)
	{
		cout << "Cannot duplicate pipe!!" << endl;
		return 0;
	}				

	char temp[200];
	int temp2;
	char command[256];
//	char delim[] = {' ', 0};
	char * argv[256];
	int args;
	STRING path;
	STRING allcommands[] = { "cd", "Pstree", "ls", "environ", "sysinfo", "quit", "./addUser"};

//	mywindow = initscr();
//	scrollok( mywindow, true);
//	start_color();

//	printf("%d, %d\n", fds[0], fds[1]);

//	init_pair( 1, COLOR_BLACK, COLOR_BLACK);
//	init_pair( 2, COLOR_RED, COLOR_BLACK);
//        init_pair( 3, COLOR_GREEN, COLOR_BLACK);
//	init_pair( 4, COLOR_YELLOW, COLOR_BLACK);
//	init_pair( 5, COLOR_BLUE, COLOR_BLACK);
//	init_pair( 6, COLOR_MAGENTA, COLOR_BLACK);
//	init_pair( 7, COLOR_CYAN, COLOR_BLACK);
//	init_pair( 8, COLOR_WHITE, COLOR_BLACK);

	for(;;)
	{	
//		attrset( COLOR_PAIR( 8) | A_BOLD);
		path = STRING( getcwd( temp, temp2));
		printf("[%s]$ ", path.c_str());
		
		cin.getline( command, 255);
//		getnstr( command, 255);
//		printw("Certain\n");
//		attrset( COLOR_PAIR( 8));

		args = 0;
		
		for( int ind = 0; command[ind] != 0;)
		{
//			printw("ind:%d, args:%d, argv[args]:%s\n", ind, args, argv[args]);
//		
			argv[args] = command + ind;			
			
			while( command[ind] != ' ' && command[ind] != 0){
//				printw( "%c ", command[ind]);
				ind++;
			}

//			printw("  -> %d\n", (int)command[ind]);

			if( command[ind] != 0)
			{
				command[ind] = 0;
//				printw("%d, %s\n", args, argv[args]);
				ind++;
			}		

//			printw("ind:%d, args:%d, argv[args]:%s\n", ind, args, argv[args]);
			args++;
//			printw("ind:%d, args:%d, argv[args]:%s\n", ind, args, argv[args]);	
		}

		argv[args] = NULL;
		

//		argv[0] = strtok( command, delim);
		
//		for( args = 1; argv[args - 1] != 0; args++){
//			argv[args] = strtok( NULL, delim);
//			printw("%d, ", args);
//		}

//		printw("-->%s\n", command);

//		args--;

		if( argv[0] == NULL)
			continue;

//		printw("%d\n", args);
		
		
		if( allcommands[0] == argv[0])
		{
			cd( args, argv);
		}
		else if( allcommands[1] == argv[0])
		{
			if( args != 1)
			{
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf( "Pstree is not getting anything\n");
//				attrset( COLOR_PAIR( 8));	
			}
			else
				Pstree();
		}
		else if( allcommands[2] == argv[0])
		{
			ls( args, argv);
		}
		else if( allcommands[3] == argv[0])
		{
			if( args != 1)
			{
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf( "environ is not getting anything\n");
//				attrset( COLOR_PAIR( 8));	
			}
			else
				myenviron();
		}	
		else if( allcommands[4] == argv[0])
		{
			if( args != 1)
			{
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf( "sysinfo is not getting anything\n");
//				attrset( COLOR_PAIR( 8));	
			}
			else		
				sysinfo();
		}
		else if( allcommands[5] == argv[0])
		{
//			attrset( COLOR_PAIR( 8));
//			printf( "\nPress any key to continue ...");
//			getch();
//			endwin();
			break;
		}
		else if( allcommands[6] == argv[0])
		{
			if( args != 2)
			{
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf("Add user gets 2 parameters!!\n");
//				attrset( COLOR_PAIR( 8));					
				continue;
			}
			
			int child_status;
			pid_t id = fork();

			if( id == -1){
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf("An internal error occured in fork!!\n");
//				attrset( COLOR_PAIR( 8));			
			}else if( id == 0){			
//				printw("In child id is %d.\n",id);
				execvp (argv[0], argv);
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf("An internal error occurred in execvp!!\n");
//				attrset( COLOR_PAIR( 8));						
//				abort ();
			}else{
				addUsrPid = id;
				keeploop = true;

				while( keeploop);
//				cout << "In parent id is " << id << " ." << endl;
//				wait (&child_status);
		
//				if (! WIFEXITED (child_status)){
//					attrset( COLOR_PAIR( 2) | A_BOLD);
//					printw("The child process exited abnormally!!\n");
//					attrset( COLOR_PAIR( 8));						
//				}
			}	
		
		}
		else
		{
			int child_status;
			pid_t id = fork();

			if( id == -1){
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf("An internal error occured in fork!!\n");
//				attrset( COLOR_PAIR( 8));			
			}else if( id == 0){
//				printw("In child id is %d.\n",id);
				execvp (argv[0], argv);
//				attrset( COLOR_PAIR( 2) | A_BOLD);
				printf("An internal error occurred in execvp!!\n");
//				attrset( COLOR_PAIR( 8));						
//				abort ();
			}else{
//				cout << "In parent id is " << id << " ." << endl;
				waitpid( id, &child_status, 0);
		
				if (! WIFEXITED (child_status)){
//					attrset( COLOR_PAIR( 2) | A_BOLD);
					printf("The child process exited abnormally!!\n");
//					attrset( COLOR_PAIR( 8));						
				}
			}	
		}

//		if( command)
//			free(command);
	}
	
//	delete [] temp;
	return 0;
}
